App/App/Areas/Admin/Controllers/HomeController.cs
using System.Web.Mvc;
using App.Class;

namespace App.Areas.Admin.Controllers
{
    [Authorize(Roles = Role.Admin)]
    public class HomeController : Controller
    {
        // GET: Admin/Home
        public ActionResult Index() //vytvoření úvodní stránky
        {
            if (Request.IsAjaxRequest())
                {
                    return PartialView();
                }                
         return View();
        }
    }
}

App/App/Areas/User/Controllers/HomeController.cs
using System.Web.Mvc;
using App.Class;

namespace App.Areas.User.Controllers
{
    [Authorize(Roles = Role.User)]
    public class HomeController : Controller
    {
        // GET: User/Home
        public ActionResult IndexUser()
        {
            if (Request.IsAjaxRequest())
            {
                return PartialView();
            }
            return View();
        }

        public ActionResult KnowProfile()
        {
            if (Request.IsAjaxRequest())
            {
                return PartialView();
            }
            return View();
        }

        public ActionResult KnowText()
        {
            if (Request.IsAjaxRequest())
            {
                return PartialView();
            }
            return View();
        }

        public ActionResult KnowVocabulary()
        {
            if (Request.IsAjaxRequest())
            {
                return PartialView();
            }
            return View();
        }

        public ActionResult KnowMessage()
        {
            if (Request.IsAjaxRequest())
            {
                return PartialView();
            }
            return View();
        }
    }
}

App/App/Areas/User/Controllers/MenuController.cs
using System.Web.Mvc;
using App.Class;
using DataAccess.Dao;

namespace App.Areas.User.Controllers
{
    [ChildActionOnly]
    [Authorize(Roles = Role.User)]
    public class MenuController : Controller
    {
        // GET: User/Menu
        public ActionResult Index()
        {
            var vyukaUserDao = new VyukaUserDao();
            var vyukaUser = vyukaUserDao.GetByLogin(User.Identity.Name);
            return View("UserMenu", vyukaUser);
        }

        public ActionResult SidemenuProfil()
        {
            return PartialView();
        }

        public ActionResult SidemenuVocabulary()
        {
            return PartialView();
        }

        public ActionResult SidemenuText()
        {
            ViewBag.Categories = new ArticleCategoryDao().GetAll();
            return PartialView();
        }

        public ActionResult SidemenuTest()
        {
            ViewBag.Categories = new ArticleCategoryDao().GetAll();
            return PartialView();
        }

        public ActionResult SidemenuTestStart()
        {
            ViewBag.Categories = new ArticleCategoryDao().GetAll();
            return PartialView();
        }

        public ActionResult SidemenuTestSubmit()
        {
            ViewBag.Categories = new ArticleCategoryDao().GetAll();
            return PartialView();
        }

        public ActionResult SidemenuHome()
        {
            ViewBag.Categories = new ArticleCategoryDao().GetAll();
            return PartialView();
        }

        public ActionResult SidemenuMessage()
        {
            return PartialView();
        }
    }
}

App/App/Areas/User/Controllers/MessageController.cs
using System.Web.Mvc;
using App.Class;
using DataAccess.Dao;
using DataAccess.Model;

namespace App.Areas.User.Controllers
{
    [Authorize(Roles = Role.User)]
    public class MessageController : Controller
    {
        // GET: User/Text
        public ActionResult Index()
        {
            Message message = new Message()
            {
                //nalezení jména (přezdívky) uživatele, který píše zprávu
                UserName = User.Identity.Name
            };
           
            if (Request.IsAjaxRequest())
            {
                return PartialView(message);
            }
            return View(message);
        }

        [HttpPost]
        [ValidateAntiForgeryToken]
        public ActionResult SendMessage(Message message)
        {
            if (ModelState.IsValid)
            {
                new MessageDao().Create(message);
                TempData["message-success"] = "Vaše zpárva byla úspěšně odeslána.";
                message = new Message()
                {
                    UserName = User.Identity.Name,
                    Sender = "",
                    Subject = "",
                    Text = ""
                };
                return RedirectToAction("Index", message);
            }
        
            if (Request.IsAjaxRequest())
                {
                    return PartialView("Index",message);
                }           
            return View("Index",message);
        }
    }
}

App/App/Areas/User/Controllers/TextController.cs
using System.Collections.Generic;
using System.Linq;
using System.Web.Mvc;
using App.Areas.User.Class;
using App.Class;
using DataAccess.Dao;
using DataAccess.Model;

namespace App.Areas.User.Controllers
{
    [Authorize(Roles = Role.User)]
    public class TextController : Controller
    {
        // GET: User/Text
        public ActionResult IndexTextUser()
        {
            ArticleDao articleDao = new ArticleDao();
            IList<Article> articles = articleDao.GetAll();
            IList<TestArticle> ta = new List<TestArticle>();

            foreach (Article a in articles)
            {
                if (a.TestId == 0)
                {
                    ta.Add(new TestArticle(){Article = a, Test = null});
                }
                else
                {
                    Test t = new TestDao().GetById(a.TestId);
                    ta.Add(new TestArticle(){Article = a, Test = t});
                }
            }

            if (Request.IsAjaxRequest())
            {
                return PartialView(ta);
            }
            return View(ta);
        }

        public ActionResult Detail(int id)
        {
            ArticleDao articleDao = new ArticleDao();
            Article a = articleDao.GetById(id);

            ViewBag.Categories = new ArticleCategoryDao().GetAll();

            if (Request.IsAjaxRequest())
            {
                return PartialView(a);
            }
            return View(a);
        }

        public ActionResult CategoryUser(int id)
        {
            IList<Article> article = new ArticleDao().GetArticlesInCategoryId(id);
            ViewBag.Categories = new ArticleCategoryDao().GetAll();
            IList<TestArticle> ta = new List<TestArticle>();

            foreach (Article a in article)
            {
                if (a.TestId == 0)
                {
                    ta.Add(new TestArticle() { Article = a, Test = null });
                }
                else
                {
                    Test t = new TestDao().GetById(a.TestId);
                    ta.Add(new TestArticle() { Article = a, Test = t });
                }
            }

            if (Request.IsAjaxRequest())
            {
                return PartialView("IndexTextUser", ta);
            }
            return View("IndexTextUser", ta);
        }

        public JsonResult SearchArticles(string query)
        {
            ArticleDao articleDao = new ArticleDao();
            IList<Article> articles = articleDao.SearchArticle(query);

            List<string> names = (from Article a in articles select a.Name).ToList();

            return Json(names, JsonRequestBehavior.AllowGet);
        }

        public ActionResult SearchTu(string phrase)
        {
            ArticleDao articleDao = new ArticleDao();
            ViewBag.Categories = new ArticleCategoryDao().GetAll();
            IList<Article> article = articleDao.SearchArticle(phrase);
            IList<TestArticle> ta = new List<TestArticle>();

            foreach (Article a in article)
            {
                if (a.TestId == 0)
                {
                    ta.Add(new TestArticle() { Article = a, Test = null });
                }
                else
                {
                    Test t = new TestDao().GetById(a.TestId);
                    ta.Add(new TestArticle() { Article = a, Test = t });
                }
            }

            if (Request.IsAjaxRequest())
            {
                return PartialView("IndexTextUser", ta);
            }
            return View("IndexTextUser", ta);
        }
    }
}

App/App/Areas/User/Controllers/VocabularyController.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web.Mvc;
using App.Class;
using DataAccess.Dao;
using DataAccess.Model;

namespace App.Areas.User.Controllers
{
    [Authorize(Roles = Role.User)]
    public class VocabularyController : Controller
    {
        // GET: User/Vocabulary
        public ActionResult IndexVocabularyUser(int? page)
        {
            int itemsOnPage = 5;
            int pg = page.HasValue ? page.Value : 1; 
            int totalWords;

            VocabularyDao vocabularyDao = new VocabularyDao();
            IList<Vocabulary> vocabulary = vocabularyDao.GetVocabularyPaged(itemsOnPage, pg, out totalWords);

            ViewBag.Pages = (int)Math.Ceiling((double)totalWords / (double)itemsOnPage);
            ViewBag.CurrentPage = pg;

            if (Request.IsAjaxRequest())
            {
                return PartialView(vocabulary);
            }
            return View(vocabulary);
        }

        public JsonResult SearchWords(string query)
        {
            VocabularyDao vocabularyDao = new VocabularyDao();
            IList<Vocabulary> vocabulary = vocabularyDao.SearchWord(query);

            List<string> names = (from Vocabulary a in vocabulary select a.Word).ToList();

            return Json(names, JsonRequestBehavior.AllowGet);
        }

        public ActionResult SearchVu(string phrase)
        {
            VocabularyDao vocabularyDao = new VocabularyDao();
            ViewBag.Words = vocabularyDao.GetAll();
            IList<Vocabulary> vocabulary = vocabularyDao.SearchWord(phrase);

            if (Request.IsAjaxRequest())
            {
                return PartialView("IndexVocabularyUser", vocabulary);
            }
            return View("IndexVocabularyUser", vocabulary);
        }
    }
}

App/App/Controllers/HomeController.cs
using System.Web.Mvc;

namespace App.Controllers
{
    public class HomeController : Controller
    {
        // GET: Home
        public ActionResult Index()
        {
            if (Request.IsAjaxRequest())
            {
                return PartialView();
            }
        return View();
        }

        public ActionResult Radvice()
        {
            if (Request.IsAjaxRequest())
            {
                return PartialView();
            }
            return View();
        }

        public ActionResult Ladvice()
        {
            if (Request.IsAjaxRequest())
            {
                return PartialView();
            }
            return View();
        }
    }
}

App/App/Areas/User/Views/Home/IndexUser.cshtml
@{Html.RenderAction("SidemenuHome", "Menu");}

<div class="dashboard-wrapper">
    <div class="container-fluid dashboard-content">
        <h2>Vítejte, nyní jste přihlášen/a</h2>
        <p>
            Pokud chcete naplno používat tuto stránku, použíjte horní lištu a vyberte si některou ze záložek, kde se můžete začít vzdělávat.
            Záložkami rozumíme - <strong>Profil, Učební texty, Slovníček, Napište nám</strong>, které jsou na obrázku podtrženy
            červenou čárou.
        </p>
        <img src="@Url.Content("~/obrazky/uvodniStranka/home-lista.jpg")" class="img-fluid" alt="Lista">
        <br />
        <br />
        <p> Pokud si chcete přečíst návod o tom, jak pracovat s jednotlivými záložkami, rozklikněte něktezé z polí v menu nalevo.</p>
        <br />
        <p>
            Pokud skončíte s prací na této stránce, nezapomeňte se odhlásit tlačítkem <strong>Odhlásit</strong>, které je
            na liště úplně v pravo. Na obrázku je pro lepší přehlednost v červeném rámačku.
        </p>
        <img src="@Url.Content("~/obrazky/uvodniStranka/home-odhlaseni.jpg")" class="img-fluid" alt="Logout">
        <br />
    </div>
</div>

App/App/Areas/User/Views/Home/KnowMessage.cshtml
@{Html.RenderAction("SidemenuHome", "Menu");}

<div class="dashboard-wrapper">
    <div class="container-fluid dashboard-content">
        <h2>Jak pracovat se záložkou Napište nám</h2>
        <p>Pokud rozkliknete záložku <strong>Napište nám</strong> ukáže se Vám zhruba takovýto pohled:</p>
        <br />
        <img src="@Url.Content("~/obrazky/uvodniStranka/napisteNam/email.jpg")" class="img-fluid" alt="Forum">
        <br />
        <p>
            Pokud si stále nejste jisti, jak si vytvořit e-mail, abyste mohli poslat zprávu jednomu z našich administrátorů, použíjte
            tlačítko vlevo <strong>Informace o e-mailu</strong> (zde v růžovém rámečku) a najděte si informace o tom, jak se vytváří e-mail.
        </p>
        <p>
            Pokud již máte vytvořený e-mail, vyplňte ho do pole v zeleném rámečku. Pokračujte tak i s vyplněním Předmětu zprávy - toto
            pole není povinné (modrý rámeček) a následně napiště, co chcete našim administrátorům sdělit (pole ve žlutém rámečku).
        </p>
        <p>
            Pokud chcete odeslat zprávu našim administrátorům, stačí po jejím napsání kliknout na talčítko <strong>Odeslat</strong> a zpráva
            se pošle. Pokud čekáte odpověď na zprávu, kontrolujte svou e-mailovou schránku, kam Vám naši administrátoři odpoví.
        </p>
        <div class="form-group">
            <div class="col-sm-2 col-sm-10">
                @Ajax.ActionLink("Podívat se do Napište nám", "Index", "Message", new { Area = "User" }, new AjaxOptions() { UpdateTargetId = "dynamicContent", InsertionMode = InsertionMode.Replace }, new { @class = "btn btn-primary" })
                @Ajax.ActionLink("Zpět na hlavní stránku", "IndexUser", "Home", new { Area = "User" }, new AjaxOptions() { UpdateTargetId = "dynamicContent", InsertionMode = InsertionMode.Replace }, new { @class = "btn btn-primary" })

            </div>
        </div>
    </div>
</div>

App/App/Areas/User/Views/Home/KnowProfile.cshtml
@{Html.RenderAction("SidemenuHome", "Menu");}

<div class="dashboard-wrapper">
    <div class="container-fluid dashboard-content">
        <h2>Jak pracovat se záložkou Profil</h2>
        <p>Pokud rozkliknete záložku <strong>Profil</strong> ukáže se Vám zhruba takovýto pohled:</p>
        <br />
        <img src="@Url.Content("~/obrazky/uvodniStranka/profil/profile.jpg")" class="img-fluid" alt="Profil">
        <br />
        <p>Vidíte zde několik záložek v levém bočním menu <i>Profil, Upravit profil, Upravit heslo a Moje Testy</i>, tyto záložky si nyní postupně přiblížíme.</p>
        <p>
            Jak je vidno, v první záložce <strong>Profil</strong> jsou Vaše údaje, jako jsou jméno, příjmení, datum narození, registrace a datum posledního
            přihlášení na profilu. Tyto informace vidíte jen Vy a naši administrátoři, takže se nemusíte bát.
        </p>
        <p>
            Pokud chcete Váš profil upravit, přesunete se na další záložku, na obrázku je pro lepší přehlednost tato záložka podtržena
            zelenou barvou.
        </p>
        <br />
        <img src="@Url.Content("~/obrazky/uvodniStranka/profil/uprava-profilu.jpg")" class="img-fluid" alt="Uprava profilu">
        <br />
        <p>
            V modrém rámečku je Vaše jméno a příjmení, ta musí být vyplněná pokaždé. Proto je měňte pouze, když si všimnete, že jste
            udělali ve svém jméně překlep. V oranžovém rámečku můžete, ale nemusíte vyplnit Vaše datum narození. Toto datum opět uvidíte jenom
            Vy a nebo administrátor těchto stránek. V růžovém rámečku si můžete vybrat profilovou fotku, pakliže nějaké fotky máte ve svém
            počítači. Pokud nevíte, jak se taková fotka nahraje. Nezoufejte, budete si to moct nastudovat v některém z našich učebních článků.
        </p>
        <p>
            Rámečky jsou zde samozřejmě jen pro lepší přehlednost. Když upravíte své osobní údaje, není nic lehčího, než kliknout na talčítko
            <strong>Upravit profil</strong> a Vaše nové informace se uloží na Váš profil. Toto talčítko je zde v červeném rámečku.
        </p>
        <br />
        <img src="@Url.Content("~/obrazky/uvodniStranka/profil/profil-heslo.jpg")" class="img-fluid" alt="Uprava hesla">
        <br />
        <p>
            Když chcete změnit své heslo, které jste zadávali při registraci, použíjte záložku <strong>Upravit heslo</strong>.
            Objeví se Vám formulář, kde musíte nejprve zadat své původní staré heslo (na obrázku v modrém rámečku) a poté zadat nové heslo,
            které musíte napsat dvakrát (oranžový rámeček na obrázku). Nezapomínejte, že heslo musí obsahovat minimálně 5 znaků.
            Abyste své nové heslo uložili, stačí kliknout na <strong>Změnit heslo</strong> (v červeném rámečku na obrázku).
        </p>
        <br />
        <img src="@Url.Content("~/obrazky/uvodniStranka/profil/profil-testy.jpg")" class="img-fluid" alt="Uprava profilu">
        <br />
        <p>
            Až se naučíte pracovat s články, které si nastudujete. Můžete si ověřit své znalosti pomocí jednoduchých krátkých testů.
            Výsledky těchot testů, datum jejich vyplnění, bodové a procentuální hodnocení uvidíte v záložce <strong>Moje testy</strong>.
        </p>
        <div class="form-group">
            <div class="col-sm-2 col-sm-10">
                @Ajax.ActionLink("Podívat se na Profil", "Profil", "Profil", new { Area = "User" }, new AjaxOptions() { UpdateTargetId = "dynamicContent", InsertionMode = InsertionMode.Replace }, new { @class = "btn btn-primary" })
                @Ajax.ActionLink("Zpět na hlavní stránku", "IndexUser", "Home", new { Area = "User" }, new AjaxOptions() { UpdateTargetId = "dynamicContent", InsertionMode = InsertionMode.Replace }, new { @class = "btn btn-primary" })
            </div>
        </div>
    </div>
</div>

App/App/Areas/User/Views/Home/KnowText.cshtml
@{Html.RenderAction("SidemenuHome", "Menu");}

<div class="dashboard-wrapper">
    <div class="container-fluid dashboard-content">
        <h2>Jak pracovat se záložkou Učební texty</h2>
        <p>Pokud rozkliknete složku <strong>Učební texty</strong> ukáže se Vám zhruba takovýto pohled:</p>
        <br />
        <img src="@Url.Content("~/obrazky/uvodniStranka/vyukoveTexty/text-main.jpg")" class="img-fluid" alt="Clanky">
        <br />
        <p>
            Na levé straně v zeleném rámečku vidíte několik záložek. To jsou názvy kategorií tetxů, ve kterých jsou zeřazeny
            jednotlivé články právě podle těchto kategorií. Záložky se mohou měnit, protože pro Vás chceme neustále zlepšovat
            články, ze kterých se můžete učit.
        </p>
        <p>
            Uprostřed je tabulka, kde vidíte fialově podtržený text. To je název článku, na který když kliknete, zobrazí se Vám
            jeho obsah a vy si můžete číst a vzdělávat se. Obsah článku vypadá nějak takto:
        </p>
        <img src="@Url.Content("~/obrazky/uvodniStranka/vyukoveTexty/text-detail.jpg")" class="img-fluid" alt="Detail článku">
        <br />
        <p>
            V modrém rámečku na prvním obrázku vidíte vyhledávací lištu. Tu můžete použivat i v záložce Slovíčka. Stačí zde napsat první dvě písmenka
            slova nebo věty, kterou chcete vyhledávat a slovo se automaticky doplní. Je to výhodné, pokud si pamatujete název článku,
            který si chcete číst, nemusíte ho vyhledávat proklikáním se v kategoriích.
        </p>
        <p>
            Na prvním obrázku ještě vidíte v každém řádku jednotlivých článků políčko <strong>Test</strong>, na který, když kliknete,
            zobrazí se Vám zhruba takový pohled:
        </p>
        <img src="@Url.Content("~/obrazky/uvodniStranka/vyukoveTexty/start-test.jpg")" class="img-fluid" alt="Zahájit test">
        <br />
        <p>
            Zde můžete vidět své předchozí pokusy a jejich hodnocení. Pokud jste test zatím nezkoušeli, nezobrazí se vám tam nic. V boční liště
            v modrém rámečku je tlačítko <strong>Zpět na všechny články</strong> to stiskněte, pokud ještě nejte připraveni psát test. Jinak stiskněte
            zelené tlačítko nahoře a test pro danou kapitolu se zahájí. Zobrazí se Vám takový pohled:
        </p>
        <img src="@Url.Content("~/obrazky/uvodniStranka/vyukoveTexty/test-start.jpg")" class="img-fluid" alt="Test">
        <br />
        <p>
            Vždy si musíte přečíst otázku a k ní vybrat odpvěď. Odpověď může být buď jedna a nebo více, pokud stále nechcete psát test, vraťte se stisknutím
            tlačítka vlevo <strong>Zpět na všechny články</strong>. Pokud jste test vyplnil/a, stiskněte dole pod testem modré tlačítko <strong>Ukončit test</strong>.
            Po stisknutí tohoto tlačítka se Vám zobrazí stránka, kde bude test vyhodnocen:
        </p>
        <img src="@Url.Content("~/obrazky/uvodniStranka/vyukoveTexty/vyhonocenyTest.jpg")" class="img-fluid" alt="Vyhodnocení testu">
        <br />
        <p>
            Zde vidíte zeleně označené správné odpovědi a červeně označené špatné odpovědi. Pokud odpověď svítí červeně, ale není označená,
            znamená to, že to byla správná odpověď.
        </p>
        <div class="form-group">
            <div class="col-sm-2 col-sm-10">
                @Ajax.ActionLink("Podívat se do Učebních textů", "IndexTextUser", "Text", new { Area = "User" }, new AjaxOptions() { UpdateTargetId = "dynamicContent", InsertionMode = InsertionMode.Replace }, new { @class = "btn btn-primary" })
                @Ajax.ActionLink("Zpět na hlavní stránku", "IndexUser", "Home", new { Area = "User" }, new AjaxOptions() { UpdateTargetId = "dynamicContent", InsertionMode = InsertionMode.Replace }, new { @class = "btn btn-primary" })
            </div>
        </div>
    </div>
</div>

App/App/Areas/User/Views/Home/KnowVocabulary.cshtml
@{Html.RenderAction("SidemenuHome", "Menu");}

<div class="dashboard-wrapper">
    <div class="container-fluid dashboard-content">
        <h2>Jak pracovat se záložkou Slovníček</h2>
        <p>Pokud rozkliknete záložku <strong>Slovníček</strong> ukáže se Vám zhruba takovýto pohled:</p>
        <br />
        <img src="@Url.Content("~/obrazky/uvodniStranka/slovnicek/slovnicek.jpg")" class="img-fluid" alt="Slovnicek">
        <br />
        <p>
            Jak už jsme si ukázali v záložce <strong>Učební texty</strong> i zde je vyhledávací lišta v modrém rámečku, kde si můžete vyhledat
            slovíčko, které zrovna hledáte. Je to určitě šikovné, pokud narazíte v textu na něco, čemu nerozumíte.
        </p>
        <p>Zeleně podtržené je slovíčko a vedle něj je jeho stručný význam.</p>
        <p>
            Ve žlutém rámečku je stránkování slovíček. To znamená, že je slovíček více, proto musíte přetočit na další stránku,
            stejně jako byste přetáčeli list knihy.
        </p>
        <div class="form-group">
            <div class="col-sm-2 col-sm-10">
                @Ajax.ActionLink("Podívat se do Slovníčku", "IndexVocabularyUser", "Vocabulary", new { Area = "User" }, new AjaxOptions() { UpdateTargetId = "dynamicContent", InsertionMode = InsertionMode.Replace }, new { @class = "btn btn-primary" })
                @Ajax.ActionLink("Zpět na hlavní stránku", "IndexUser", "Home", new { Area = "User" }, new AjaxOptions() { UpdateTargetId = "dynamicContent", InsertionMode = InsertionMode.Replace }, new { @class = "btn btn-primary" })
            </div>
        </div>
    </div>
</div>